/*
        MYASM v1.00                           (c) 1996 NikSoft International
        --------------------------------------------------------------------
        NAMES.H

        Source file included in the lexical analyzer.
        Definition of all reserved identifier names.

        03/11/96 19.37  Version 1.00
*/


static char *reg_names[] = {	       /* register names, as strings */
    "\0", "AH", "AL", "AX", "BH", "BL", "BP", "BX", "CH", "CL", "CR0",
    "CR2", "CR3", "CR4", "CS", "CX", "DH", "DI", "DL", "DR0", "DR1",
    "DR2", "DR3", "DR6", "DR7", "DS", "DX", "EAX", "EBP", "EBX",
    "ECX", "EDI", "EDX", "ES", "ESI", "ESP", "FS", "GS", "SI", "SP",
    "SS", "ST0", "ST1", "ST2", "ST3", "ST4", "ST5", "ST6", "ST7",
    "TR3", "TR4", "TR5", "TR6", "TR7"
};


static char *insn_names[] = {	       /* instruction names, as strings */
    "AAA", "AAD", "AAM", "AAS", "ADC", "ADD", "AND", "ARPL",
    "BOUND", "BSF", "BSR", "BSWAP", "BT", "BTC", "BTR", "BTS",
    "CALL", "CBW", "CDQ", "CLC", "CLD", "CLI", "CLTS", "CMC", "CMP",
    "CMPSB", "CMPSD", "CMPSW", "CMPXCHG", "CMPXCHG8B", "CPUID",
    "CWD", "CWDE", "DAA", "DAS", "DB", "DD", "DEC", "DIV", "DQ",
    "DT", "DW", "ENTER", "EQU", "F2XM1", "FABS", "FADD", "FADDP",
    "FBLD", "FBSTP", "FCHS", "FCLEX", "FCMOVB", "FCMOVBE", "FCMOVE",
    "FCMOVNB", "FCMOVNBE", "FCMOVNE", "FCMOVNU", "FCMOVU", "FCOM",
    "FCOMI", "FCOMIP", "FCOMP", "FCOMPP", "FCOS", "FDECSTP",
    "FDISI", "FDIV", "FDIVP", "FDIVR", "FDIVRP", "FENI", "FFREE",
    "FIADD", "FICOM", "FICOMP", "FIDIV", "FIDIVR", "FILD", "FIMUL",
    "FINCSTP", "FINIT", "FIST", "FISTP", "FISUB", "FISUBR", "FLD",
    "FLD1", "FLDCW", "FLDENV", "FLDL2E", "FLDL2T", "FLDLG2",
    "FLDLN2", "FLDPI", "FLDZ", "FMUL", "FMULP", "FNOP", "FPATAN",
    "FPREM", "FPREM1", "FPTAN", "FRNDINT", "FRSTOR", "FSAVE",
    "FSCALE", "FSETPM", "FSIN", "FSINCOS", "FSQRT", "FST", "FSTCW",
    "FSTENV", "FSTP", "FSTSW", "FSUB", "FSUBP", "FSUBR", "FSUBRP",
    "FTST", "FUCOM", "FUCOMI", "FUCOMIP", "FUCOMP", "FUCOMPP",
    "FXAM", "FXCH", "FXTRACT", "FYL2X", "FYL2XP1", "HLT", "ICEBP",
    "IDIV", "IMUL", "IN", "INC", "INSB", "INSD", "INSW", "INT",
    "INT1", "INT01", "INT3", "INTO", "INVD", "INVLPG", "IRET",
    "IRETD", "IRETW", "JCXZ", "JECXZ", "JMP", "LAHF", "LAR", "LDS",
    "LEA", "LEAVE", "LES", "LFS", "LGDT", "LGS", "LIDT", "LLDT",
    "LMSW", "LOADALL", "LODSB", "LODSD", "LODSW", "LOOP", "LOOPE",
    "LOOPNE", "LOOPNZ", "LOOPZ", "LSL", "LSS", "LTR", "MOV",
    "MOVSB", "MOVSD", "MOVSW", "MOVSX", "MOVZX", "MUL", "NEG",
    "NOP", "NOT", "OR", "OUT", "OUTSB", "OUTSD", "OUTSW", "POP",
    "POPA", "POPAD", "POPAW", "POPF", "POPFD", "POPFW", "PUSH",
    "PUSHA", "PUSHAD", "PUSHAW", "PUSHF", "PUSHFD", "PUSHFW", "RCL",
    "RCR", "RDMSR", "RDPMC", "RDTSC", "RESB", "RESD", "RESQ",
    "REST", "RESW", "RET", "RETF", "RETN", "ROL", "ROR", "RSM",
    "SAHF", "SAL", "SALC", "SAR", "SBB", "SCASB", "SCASD", "SCASW",
    "SGDT", "SHL", "SHLD", "SHR", "SHRD", "SIDT", "SLDT", "SMSW",
    "STC", "STD", "STI", "STOSB", "STOSD", "STOSW", "STR", "SUB",
    "TEST", "UMOV", "VERR", "VERW", "WAIT", "WBINVD", "WRMSR",
    "XADD", "XCHG", "XLATB", "XOR"
};


static char *icn[] = {		       /* conditional instructions */
    "CMOV", "J", "SET"
};


static int ico[] = {		       /* and the corresponding opcodes */
    I_CMOVcc, I_Jcc, I_SETcc
};


static char *conditions[] = {	       /* condition code names */
    "A", "AE", "B", "BE", "C", "E", "G", "GE", "L", "LE", "NA", "NAE",
    "NB", "NBE", "NC", "NE", "NG", "NGE", "NL", "NLE", "NO", "NP",
    "NS", "NZ", "O", "P", "PE", "PO", "S", "Z"
};


static char *keywords[] = {
    "DIV", "ENDP", "LOCAL", "MOD", "PROC", "TIMES", "USES"
};


static char *special_names[] = {       /* and the actual text */
    "BYTE", "DWORD", "FAR", "LONG", "NEAR", "QWORD", "SHORT", "TO",
    "TWORD", "WORD"
};


static char *prefix_names[] = {
    "LOCK", "REP", "REPE", "REPNE", "REPNZ", "REPZ"
};

/* --------- End of File --------------------------------------- */
